using System.Collections;using System.Collections.Generic;using UnityEngine;using System.Linq;using UnityEngine.UI;namespace PluginIdea.IW{public class InteractiveWaterMono : MonoBehaviour{public float width = 1, height = 1;public int PixelsPerMeter = 36;public GameObject actualWaterPlane;GameObject RefPlane;GameObject RigRoot;public GameObject RigRenderPlane;GameObject RigWaterSurface;Camera SurfaceCamera;Camera RenderCamera;Camera ObjMaskCamera;RenderTexture CameraInput;RenderTexture Propegation;RenderTexture ObjMaskInput;Transform defaultTrans;List<Material> mats = new List<Material>();public int FrameRate{set{if (inVTRenderer) inVTRenderer.frameRate = value;if (reVTRenderer) reVTRenderer.frameRate = value;}}public void Init(){CameraInput = new RenderTexture(180, 180, 0, RenderTextureFormat.RG16);Propegation = new RenderTexture(180, 180, 0, RenderTextureFormat.ARGB64);ObjMaskInput = new RenderTexture(180, 180, 0, RenderTextureFormat.Depth);RigRoot = transform.gameObject;defaultTrans = RigRoot.transform.Find("Default_Quality");RefreshWaterEffect();}public void RefreshWaterEffect(){SetUpRefPlane(width, height);SetUpRefrence();SetUpMats();CreateEffect();}private void SetUpRefPlane(float width, float height){RefPlane = GameObject.CreatePrimitive(PrimitiveType.Plane);RefPlane.transform.position = Vector3.zero;RefPlane.transform.localScale = new Vector3(width * 0.1f, 1, height * 0.1f);}private void SetUpMats(){var rdlist = GetComponentsInChildren<Renderer>(true).ToList();rdlist.ForEach(rd =>{if (!mats.Contains(rd.material)) mats.Add(rd.material);});}private void CreateEffect(){if (RefPlane){SurfaceCamera.targetTexture = CameraInput;RenderCamera.targetTexture = Propegation;ObjMaskCamera.targetTexture = ObjMaskInput;Vector3 RefScale = RefPlane.transform.localScale * 5;Vector3 RefPos = RefPlane.transform.position;Quaternion RefRot = RefPlane.transform.rotation;RigRoot.transform.position = RefPos;RigRoot.transform.rotation = RefRot;RigWaterSurface.transform.localPosition = Vector3.zero;int WidthInPixels = (int)(RefScale.x * PixelsPerMeter + 0.5);int HeightInPixels = (int)(RefScale.z * PixelsPerMeter + 0.5);Vector3 newLocalScale = new Vector3((float)WidthInPixels / PixelsPerMeter, 1, (float)HeightInPixels / PixelsPerMeter);RigWaterSurface.transform.localScale = newLocalScale;RigRenderPlane.transform.localScale = newLocalScale;SurfaceCamera.orthographicSize = newLocalScale.z;RenderCamera.orthographicSize = newLocalScale.z;ObjMaskCamera.orthographicSize = newLocalScale.z;CameraInput.Release();CameraInput.width = WidthInPixels;CameraInput.height = HeightInPixels;CameraInput.Create();Propegation.Release();Propegation.width = WidthInPixels;Propegation.height = HeightInPixels;Propegation.Create();ObjMaskInput.Release();ObjMaskInput.width = WidthInPixels;ObjMaskInput.height = HeightInPixels;ObjMaskInput.Create();for (int i = 0;i < mats.Count;i++){SetMaterial(mats[i], WidthInPixels, HeightInPixels);}RefPlane.SetActive(false);RigRoot.gameObject.SetActive(false);RigRoot.gameObject.SetActive(true);}}private void SetMaterial(Material mat, int WidthInPixels, int HeightInPixels){if (mat){if (mat.HasProperty("_ImgWidth")){mat.SetInt("_ImgWidth", WidthInPixels);}if (mat.HasProperty("_imgWidth")){mat.SetInt("_imgWidth", WidthInPixels);}if (mat.HasProperty("_ImgHeight")){mat.SetInt("_ImgHeight", HeightInPixels);}if (mat.HasProperty("_imgHeight")){mat.SetInt("_imgHeight", HeightInPixels);}}}private VTRenderer inVTRenderer, reVTRenderer;void SetUpRefrence(){Transform[] trans = RigRoot.GetComponentsInChildren<Transform>(true);foreach (Transform t in trans){if (t.gameObject.name == "D_Surface"){RigWaterSurface = t.gameObject;MeshRenderer md = RigWaterSurface.GetComponentInChildren<MeshRenderer>();md.gameObject.layer = LayerMask.NameToLayer("Water");var mat = md.material;mat.SetTexture("_BumpMap", Propegation);}if (t.gameObject.name == "D_Render_Plane_q"){RigRenderPlane = t.gameObject;var mat = RigRenderPlane.GetComponent<MeshRenderer>().material;mat.SetTexture("_MainTex", Propegation);mat.SetTexture("_CamIn", CameraInput);mat.SetTexture("_ObjMask", ObjMaskInput);}if (t.gameObject.name == "D_Cam_In"){SurfaceCamera = t.gameObject.GetComponent<Camera>();inVTRenderer = Utils.GetSafeComponent<VTRenderer>(t.gameObject);}if (t.gameObject.name == "D_Render_Cam"){RenderCamera = t.gameObject.GetComponent<Camera>();reVTRenderer = Utils.GetSafeComponent<VTRenderer>(t.gameObject);}if (t.gameObject.name == "D_CamMask"){ObjMaskCamera = t.gameObject.GetComponent<Camera>();}if (t.gameObject.name == "D_Top"){actualWaterPlane = t.gameObject;}}}private void OnDestroy(){Destroy(Propegation);Destroy(CameraInput);}}}