using MeshVR;using MVR.FileManagementSecure;using SimpleJSON;using System;using System.Collections;using System.Collections.Generic;using System.Linq;using System.Text;using UnityEngine;using UnityEngine.UI;using Request = MeshVR.AssetLoader.AssetBundleFromFileRequest;using UnityEngine.XR;namespace PluginIdea.IW{public class ReflectionMono : MonoBehaviour{public bool isRenderRateFollowGame;public float customRenderRate;private float refreshDur;public bool isBlur;[SerializeField]        protected bool _disablePixelLights;protected int _oldReflectionTextureSize;[SerializeField]        public int _textureSize = 1024;protected int _oldAntiAliasing;[SerializeField]        protected int _antiAliasing = 8;[SerializeField]        protected float _reflectionOpacity = 0.5f;[SerializeField]        protected float _reflectionBlend = 1f;[SerializeField]        protected float _surfaceTexturePower = 1f;[SerializeField]        protected float _specularIntensity = 1f;protected Color _currentReflectionColor;public static bool globalEnabled = true;public Transform altObjectWhenMirrorDisabled;public bool useSameMaterialWhenMirrorDisabled;public float m_ClipPlaneOffset = 0.005f;public LayerMask m_ReflectLayers = -1;public bool m_UseObliqueClip = true;public bool renderBackside;protected Hashtable m_ReflectionCameras = new Hashtable();protected RenderTexture m_ReflectionTextureLeft;protected RenderTexture m_ReflectionTextureRight;protected static bool s_InsideRendering;private Renderer pp;private float aspect;private RenderTexture defaultReflectRT;public void Init(){pp = GetComponent<Renderer>();blurMat = InteractiveWaterPro.dic_name2Mats["GaussianBlur"];aspect = (float)Screen.height / Screen.width;defaultReflectRT = new RenderTexture(1, 1, 0);}protected void SetMaterialProp(string propName, float propValue){Renderer component = pp.GetComponent<Renderer>();if (component != null){Material[] array;if (Application.isPlaying){array = component.materials;}else{array = component.sharedMaterials;}foreach (Material material in array){if (material.HasProperty(propName)){material.SetFloat(propName, propValue);}}}}private void RenderMirror(Camera reflectionCamera){Vector3 position = pp.transform.position;Vector3 up = pp.transform.up;float w = -Vector3.Dot(up, position) - this.m_ClipPlaneOffset;Vector4 plane = new Vector4(up.x, up.y, up.z, w);Matrix4x4 zero = Matrix4x4.zero;CalculateReflectionMatrix(ref zero, plane);reflectionCamera.worldToCameraMatrix *= zero;if (this.m_UseObliqueClip){Vector4 clipPlane = this.CameraSpacePlane(reflectionCamera, position, up, 1f);reflectionCamera.projectionMatrix = reflectionCamera.CalculateObliqueMatrix(clipPlane);}reflectionCamera.cullingMask = 1 << LayerMask.NameToLayer("Default") | 1 << LayerMask.NameToLayer("TransparentFX");GL.invertCulling = true;reflectionCamera.Render();GL.invertCulling = false;}private float lastRenderTime;public void OnWillRenderObject(){refreshDur = 1f / customRenderRate;if (!isRenderRateFollowGame && Time.time - lastRenderTime < refreshDur) return;lastRenderTime = Time.time;bool isVR = Utils.IsInVR();Camera current = Camera.current;if (!current){return;}Vector3 rhs = current.transform.position - pp.transform.position;if (!this.renderBackside){float num = Vector3.Dot(pp.transform.up, rhs);if (num <= 0.001f){return;}}if (s_InsideRendering){return;}s_InsideRendering = true;Camera camera;this.CreateMirrorObjects(current, out camera);int pixelLightCount = QualitySettings.pixelLightCount;if (this._disablePixelLights){QualitySettings.pixelLightCount = 0;}this.UpdateCameraModes(current, camera);Vector3 position = current.transform.position;if (current.stereoEnabled){if (current.stereoTargetEye == StereoTargetEyeMask.Both){camera.ResetWorldToCameraMatrix();if (CameraTarget.rightTarget != null && CameraTarget.rightTarget.targetCamera != null && current.transform.parent != null){camera.transform.position = current.transform.parent.TransformPoint(InputTracking.GetLocalPosition(XRNode.RightEye));camera.transform.rotation = current.transform.parent.rotation * InputTracking.GetLocalRotation(XRNode.RightEye);camera.worldToCameraMatrix = CameraTarget.rightTarget.worldToCameraMatrix;camera.projectionMatrix = CameraTarget.rightTarget.projectionMatrix;}else{camera.transform.position = current.transform.parent.TransformPoint(InputTracking.GetLocalPosition(XRNode.RightEye));camera.transform.rotation = current.transform.parent.rotation * InputTracking.GetLocalRotation(XRNode.RightEye);camera.worldToCameraMatrix = current.GetStereoViewMatrix(Camera.StereoscopicEye.Right);camera.projectionMatrix = current.GetStereoProjectionMatrix(Camera.StereoscopicEye.Right);}camera.targetTexture = this.m_ReflectionTextureRight;this.RenderMirror(camera);camera.ResetWorldToCameraMatrix();if (CameraTarget.leftTarget != null && CameraTarget.leftTarget.targetCamera != null && current.transform.parent != null){camera.transform.position = current.transform.parent.TransformPoint(InputTracking.GetLocalPosition(XRNode.LeftEye));camera.transform.rotation = current.transform.parent.rotation * InputTracking.GetLocalRotation(XRNode.LeftEye);camera.worldToCameraMatrix = CameraTarget.leftTarget.worldToCameraMatrix;camera.projectionMatrix = CameraTarget.leftTarget.projectionMatrix;}else{camera.transform.position = current.transform.parent.TransformPoint(InputTracking.GetLocalPosition(XRNode.LeftEye));camera.transform.rotation = current.transform.parent.rotation * InputTracking.GetLocalRotation(XRNode.LeftEye);camera.worldToCameraMatrix = current.GetStereoViewMatrix(Camera.StereoscopicEye.Left);camera.projectionMatrix = current.GetStereoProjectionMatrix(Camera.StereoscopicEye.Left);}position = camera.transform.position;camera.targetTexture = this.m_ReflectionTextureLeft;this.RenderMirror(camera);}if (current.stereoTargetEye == StereoTargetEyeMask.Left){camera.ResetWorldToCameraMatrix();camera.transform.position = current.transform.position;camera.transform.rotation = current.transform.rotation;camera.worldToCameraMatrix = current.worldToCameraMatrix;camera.projectionMatrix = current.projectionMatrix;camera.targetTexture = this.m_ReflectionTextureLeft;this.RenderMirror(camera);}else if (current.stereoTargetEye == StereoTargetEyeMask.Right){camera.ResetWorldToCameraMatrix();camera.transform.position = current.transform.position;camera.transform.rotation = current.transform.rotation;camera.worldToCameraMatrix = current.worldToCameraMatrix;camera.projectionMatrix = current.projectionMatrix;camera.targetTexture = this.m_ReflectionTextureLeft;this.RenderMirror(camera);}}else{camera.ResetWorldToCameraMatrix();camera.transform.position = current.transform.position;camera.transform.rotation = current.transform.rotation;camera.worldToCameraMatrix = current.worldToCameraMatrix;camera.projectionMatrix = current.projectionMatrix;camera.targetTexture = this.m_ReflectionTextureLeft;this.RenderMirror(camera);}Material[] array;if (Application.isPlaying){array = pp.materials;}else{array = pp.sharedMaterials;}Vector4 value;value.x = position.x;value.y = position.y;value.z = position.z;value.w = 0f;if (isBlur){BlurTargetTexture(m_ReflectionTextureLeft);if (isVR) BlurTargetTexture(m_ReflectionTextureRight);}foreach (Material material in array){material.SetFloat("_IsVR", isVR ? 1:0);material.SetTexture("_LeftReflectionTex", this.m_ReflectionTextureLeft);material.SetTexture("_RightReflectionTex", this.m_ReflectionTextureRight);}if (this._disablePixelLights){QualitySettings.pixelLightCount = pixelLightCount;}s_InsideRendering = false;}protected void UpdateCameraModes(Camera src, Camera dest){if (dest == null){return;}dest.backgroundColor = src.backgroundColor;if (src.clearFlags == CameraClearFlags.Skybox){Skybox skybox = src.GetComponent(typeof(Skybox)) as Skybox;Skybox skybox2 = dest.GetComponent(typeof(Skybox)) as Skybox;if (!skybox || !skybox.material){skybox2.enabled = false;}else{skybox2.enabled = true;skybox2.material = skybox.material;}}dest.farClipPlane = src.farClipPlane;dest.nearClipPlane = src.nearClipPlane;dest.orthographic = src.orthographic;dest.fieldOfView = src.fieldOfView;dest.aspect = src.aspect;dest.orthographicSize = src.orthographicSize;}public Material blurMat;public int iteration = 1;public float BlurRadius = 0.1f;public int downSample = 1;void BlurTargetTexture(RenderTexture target){if (target == null) return;RenderTexture rt1 = RenderTexture.GetTemporary(target.width >> downSample, target.height >> downSample, 0, target.format);RenderTexture rt2 = RenderTexture.GetTemporary(target.width >> downSample, target.height >> downSample, 0, target.format);Graphics.Blit(target, rt1);for (int i = 0;i < iteration;i++){blurMat.SetVector("_offsets", new Vector4(0, BlurRadius, 0, 0));Graphics.Blit(rt1, rt2, blurMat);blurMat.SetVector("_offsets", new Vector4(BlurRadius, 0, 0, 0));Graphics.Blit(rt2, rt1, blurMat);}Graphics.Blit(rt1, target);RenderTexture.ReleaseTemporary(rt1);RenderTexture.ReleaseTemporary(rt2);}protected void CreateMirrorObjects(Camera currentCamera, out Camera reflectionCamera){reflectionCamera = null;if (!this.m_ReflectionTextureRight || !this.m_ReflectionTextureLeft || this._oldReflectionTextureSize != this._textureSize || this._oldAntiAliasing != this._antiAliasing){if (this.m_ReflectionTextureLeft){UnityEngine.Object.DestroyImmediate(this.m_ReflectionTextureLeft);}this.m_ReflectionTextureLeft = new RenderTexture(this._textureSize, (int)(_textureSize * aspect), 24);this.m_ReflectionTextureLeft.name = "__MirrorReflectionLeft" + base.GetInstanceID();this.m_ReflectionTextureLeft.antiAliasing = this._antiAliasing;this.m_ReflectionTextureLeft.isPowerOfTwo = true;this.m_ReflectionTextureLeft.hideFlags = HideFlags.DontSave;if (this.m_ReflectionTextureRight){UnityEngine.Object.DestroyImmediate(this.m_ReflectionTextureRight);}this.m_ReflectionTextureRight = new RenderTexture(this._textureSize, (int)(_textureSize * aspect), 24);this.m_ReflectionTextureRight.name = "__MirrorReflectionRight" + base.GetInstanceID();this.m_ReflectionTextureRight.antiAliasing = this._antiAliasing;this.m_ReflectionTextureRight.isPowerOfTwo = true;this.m_ReflectionTextureRight.hideFlags = HideFlags.DontSave;this._oldReflectionTextureSize = this._textureSize;this._oldAntiAliasing = this._antiAliasing;}reflectionCamera = (this.m_ReflectionCameras[currentCamera] as Camera);if (!reflectionCamera){GameObject gameObject = new GameObject(string.Concat(new object[]{"Mirror Refl Camera id",                base.GetInstanceID(),                " for ",                currentCamera.GetInstanceID()}), new System.Type[]{typeof(Camera),                typeof(Skybox)});reflectionCamera = gameObject.GetComponent<Camera>();reflectionCamera.enabled = false;reflectionCamera.transform.position = pp.transform.position;reflectionCamera.transform.rotation = pp.transform.rotation;reflectionCamera.gameObject.AddComponent<FlareLayer>();gameObject.hideFlags = HideFlags.DontSave;this.m_ReflectionCameras[currentCamera] = reflectionCamera;}}protected static float sgn(float a){if (a > 0f){return 1f;}if (a < 0f){return -1f;}return 0f;}protected Vector4 CameraSpacePlane(Camera cam, Vector3 pos, Vector3 normal, float sideSign){Vector3 point = pos + normal * this.m_ClipPlaneOffset;Matrix4x4 worldToCameraMatrix = cam.worldToCameraMatrix;Vector3 lhs = worldToCameraMatrix.MultiplyPoint(point);Vector3 rhs = worldToCameraMatrix.MultiplyVector(normal).normalized * sideSign;return new Vector4(rhs.x, rhs.y, rhs.z, -Vector3.Dot(lhs, rhs));}void CalculateReflectionMatrix(ref Matrix4x4 reflectionMat, Vector4 plane){reflectionMat.m00 = 1f - 2f * plane[0] * plane[0];reflectionMat.m01 = -2f * plane[0] * plane[1];reflectionMat.m02 = -2f * plane[0] * plane[2];reflectionMat.m03 = -2f * plane[3] * plane[0];reflectionMat.m10 = -2f * plane[1] * plane[0];reflectionMat.m11 = 1f - 2f * plane[1] * plane[1];reflectionMat.m12 = -2f * plane[1] * plane[2];reflectionMat.m13 = -2f * plane[3] * plane[1];reflectionMat.m20 = -2f * plane[2] * plane[0];reflectionMat.m21 = -2f * plane[2] * plane[1];reflectionMat.m22 = 1f - 2f * plane[2] * plane[2];reflectionMat.m23 = -2f * plane[3] * plane[2];reflectionMat.m30 = 0f;reflectionMat.m31 = 0f;reflectionMat.m32 = 0f;reflectionMat.m33 = 1f;}private void OnDisable(){if (this.m_ReflectionTextureRight){UnityEngine.Object.DestroyImmediate(this.m_ReflectionTextureRight);this.m_ReflectionTextureRight = null;}if (this.m_ReflectionTextureLeft){UnityEngine.Object.DestroyImmediate(this.m_ReflectionTextureLeft);this.m_ReflectionTextureLeft = null;}IDictionaryEnumerator enumerator = this.m_ReflectionCameras.GetEnumerator();try{while (enumerator.MoveNext()){object obj = enumerator.Current;UnityEngine.Object.DestroyImmediate(((Camera)((DictionaryEntry)obj).Value).gameObject);}}finally{IDisposable disposable;if ((disposable = (enumerator as IDisposable)) != null){disposable.Dispose();}}this.m_ReflectionCameras.Clear();foreach (Material material in pp.materials){material.SetFloat("_IsVR", Utils.IsInVR() ? 1 : 0);material.SetTexture("_LeftReflectionTex", this.defaultReflectRT);material.SetTexture("_RightReflectionTex", this.defaultReflectRT);}}private void OnDestroy(){Destroy(defaultReflectRT);}}}